(module com-nocandysw-sicp-1)

(define (square x)
  (* x x))

(define (sqrt-iter guess x)
  (if (good-enough? guess x)
      guess
      (sqrt-iter (improve guess x) x)))

(define (improve guess x)
  (average guess (/ x guess)))

(define (average x y)
  (/ (+ x y) 2))

(define (good-enough? guess x)
  (< (abs (- (square guess) x)) 0.001))

;;; Ex 1.7

(define (good-enough-delta? guess last-guess x)
  (< (/ (abs (- guess last-guess)) x) 0.001))

(define (sqrt-iter-delta guess last-guess x)
  (if (good-enough-delta? guess last-guess x)
      guess
      (sqrt-iter-delta (improve guess x) guess x)))

;;; Ex 1.11

(define (ex1.11-recursive n)
  (if (< n 3)
      n
      (+ (ex1.11-recursive (- n 1))
	 (* 2 (ex1.11-recursive (- n 2)))
	 (* 3 (ex1.11-recursive (- n 3))))))

(define (ex1.11-iter n)
  (if (< n 3)
      n
      (let lp ((n-3 0) (n-2 1) (n-1 2) (n0 3))
	(if (<= n0 n)
	    (lp n-2 n-1 (+ n-1 (* 2 n-2) (* 3 n-3)) (+ 1 n0))
	    n-1))))

;;; Ex 1.12

(define (pascal x y)
  (if (or (= 0 x) (= 0 y))
      1
      (+ (pascal (max 0 (- x 1)) (max 0 y))
	 (pascal (max 0 x) (max 0 (- y 1))))))

;;; Ex 1.16

(define (fast-expt base exponent)
  (let lp ((base base) (exponent exponent) (mul 1))
    (cond ((= 1 exponent)
	   (* base mul))
	  ((zero? (modulo exponent 2))
	   (lp (square base) (/ exponent 2) mul))
	  (else (lp base (- exponent 1) (* base mul))))))

;;; Ex 1.17

(define (double i)
  (+ i i))

(define (halve i)
  (/ i 2))

(define (silly-* a b)
  (let lp ((a a) (b b) (sum 0))
    (cond ((= b 0) 0)
	  ((= b 1) (+ a sum))
	  ((zero? (modulo b 2))
	   (lp (double a) (halve b) sum))
	  (else
	   (lp a (- b 1) (+ sum a))))))
